- include_role:
    name: prometheus
    tasks_from: dashboards.yaml
  when:
  - do_exporters
  - grafana_public_address | default(False)
  - grafana_public_address != 'not deployed'
- name: Set BigBlueButton Conferences Streaming Platform API Facts
  changed_when: False
  set_fact:
    dash_list: "{{ has_dash | default([]) | unique }}"
    bbbcsp_priv_address: "http://{{ bbbcsp_name }}.{{ namespace }}.svc.{{ cluster_domain }}:8080"
    bbbcsp_pub_address: "https://bbb-csp.{{ root_domain }}"
- block:
  - name: Reads Operator Token
    args:
      chdir: /run/secrets/kubernetes.io/serviceaccount
    changed_when: False
    register: api_token
    shell: cat token
  - name: Marks BigBlueButton Conferences Streaming Platform Provisionned
    no_log: True
    uri:
      body: |
        {
          "status": {
            "dashboards": {{ dash_list }},
            "internal": "{{ bbbcsp_priv_address }}",
            "public": "{{ bbbcsp_pub_address }}",
            "ready": true
          }
        }
      body_format: json
      headers:
        Authorization: "Bearer {{ api_token.stdout_lines[0] }}"
        Content-Type: application/merge-patch+json
      method: PATCH
      return_content: yes
      url: "https://kubernetes.default.svc.{{ cluster_domain }}/apis/{{ cr_apivers }}/namespaces/{{ namespace }}/bigbluebuttonconferencesstreamingplatforms/{{ cr_name }}/status"
      validate_certs: False
  when:
  - bbbcsp_crd is defined
  - bbbcsp_crd.resources is defined
  - bbbcsp_crd.resources | length > 0
  - >
      bbbcsp_crd.resources[0].status is not defined
      or (bbbcsp_crd.resources[0].status is defined
          and (bbbcsp_crd.resources[0].status.ready is not defined
               or ((bbbcsp_crd.resources[0].status.dashboards | default([])) | difference(dash_list)) | length > 0
               or (dash_list | difference((bbbcsp_crd.resources[0].status.dashboards | default([])))) | length > 0
               or (bbbcsp_crd.resources[0].status.internal | default('')) != bbbcsp_priv_address
               or (bbbcsp_crd.resources[0].status.public | default('')) != bbbcsp_pub_address))
